unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,OpenGL;

type
  TForm3 = class(TForm)
  procedure DrawBox(Size : GLfloat; DrawType : GLenum);
  procedure glutSolidCube(Size : GLDouble);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
        DC : HDC;
    hrc: HGLRC;
    ry : GLfloat;
    tx : GLfloat;
    xx:GLfloat;
    yy:GLfloat;

  public
    { Public declarations }
  end;
const
  BoxPoints :
    Array[0..5, 0..2] of GLfloat =
      ( (-1,  0,  0),
        ( 0,  1,  0),
        ( 1,  0,  0),
        ( 0, -1,  0),
        ( 0,  0,  1),
        ( 0,  0, -1) );
  BoxFaces :
    Array[0..5, 0..3] of GLint =
      ( (0, 1, 2, 3),
        (3, 2, 6, 7),
        (7, 6, 5, 4),
        (4, 5, 1, 0),
        (5, 6, 2, 1),
        (7, 4, 0, 3) );
var
  Form3: TForm3;
  quadObj : GLUquadricObj;
  mas,l,NNt,del,dtrub,del_st,st_tr,xt,yt:double;
  npl,Ntx,Nty,Nt:integer;

const
  //   
  ColorAxes : Array[0..3] of GLFloat = (1.0, 1.0, 1.0, 0.5);
  //  
  ColorFog : Array [0..3] of GLFloat = (0.5, 0.5, 0.5, 1.0);
  //    
  SquareAmbient : Array[0..3] of GLFloat = (0.24725, 0.1995, 0.0745, 1.0);
  SquareDiffuse : Array[0..3] of GLFloat = (0.75164, 0.60648, 0.22648, 1.0);
  SquareSpecular : Array[0..3] of GLFloat = (0.628281, 0.555802, 0.366065, 1.0);
  //  
  LightAmbient : Array[0..3] of GLFloat = (0.25, 0.25, 0.25, 1.0);
  LightDiffuse : Array[0..3] of GLFloat = (1.0, 1.0, 1.0, 1.0);
  LightSpecular: Array[0..3] of GLFloat = (1.0, 1.0, 1.0, 1.0);
  LightPosition: Array[0..3] of GLFloat = (-1.0, -1.0, -2.0, 0.5);
  LightModelAmbient: Array[0..3] of GLFloat = (0.25, 0.25, 0.25, 1.0);

  //    
  Light2Position: Array[0..3] of GLFloat = (15.0, 15.0, -5.0, 1.0);
  //  
  ColorMarker : Array[0..3] of GLFloat = (1.0, 0.0, 1.0, 1.0);

implementation

uses Unit1;

{$R *.dfm}
procedure SetDCPixelFormat (hdc : HDC);
var
 pfd : TPixelFormatDescriptor;
 nPixelFormat : Integer;
begin
 FillChar (pfd, SizeOf (pfd), 0);
 pfd.dwFlags  := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
 nPixelFormat := ChoosePixelFormat (hdc, @pfd);
 SetPixelFormat (hdc, nPixelFormat, @pfd);
end;
procedure TForm3.DrawBox(Size : GLfloat; DrawType : GLenum);
var
  V : array[0..7, 0..2] of GLfloat;
  I : GLint;
  HalfSize : GLfloat;
begin { DrawBox }
HalfSize := Size / 2;
V[0, 0] := -HalfSize;  V[1, 0] := -HalfSize;  V[2, 0] := -HalfSize;
V[3, 0] := -HalfSize;  V[4, 0] := HalfSize;   V[5, 0] := HalfSize;
V[6, 0] := HalfSize;   V[7, 0] := HalfSize;

V[0, 1] := -HalfSize;  V[1, 1] := -HalfSize;   V[4, 1] := -HalfSize;
V[5, 1] := -HalfSize;  V[2, 1] := HalfSize;   V[3, 1] := HalfSize;
V[6, 1] := HalfSize;   V[7, 1] := HalfSize;

V[0, 2] := -HalfSize;  V[3, 2] := -HalfSize;   V[4, 2] := -HalfSize;
V[7, 2] := -HalfSize;  V[1, 2] := HalfSize;   V[2, 2] := HalfSize;
V[5, 2] := HalfSize;   V[6, 2] := HalfSize;
for I := 0 to 5 do
begin
glBegin(DrawType);
glNormal3fv(@BoxPoints[I, 0]);
glVertex3fv(@V[BoxFaces[I, 0], 0]); glVertex3fv(@V[BoxFaces[I, 1], 0]);
glVertex3fv(@V[BoxFaces[I, 2], 0]); glVertex3fv(@V[BoxFaces[I, 3], 0]);
glEnd;
end;
end; { DrawBox }

procedure TForm3.glutSolidCube(Size : GLDouble);
begin
  DrawBox(Size, GL_QUADS);
end;


procedure TForm3.FormPaint(Sender: TObject);
const
no_mat              : array[0..3] of GLfloat = ( 0.0, 0.0, 0.0, 1.0 );
    mat_ambient         : array[0..3] of GLfloat = ( 0.7, 0.7, 0.7, 1.0 );
    mat_ambient_color   : array[0..3] of GLfloat = ( 0.8, 0.8, 0.2, 1.0 );
    mat_diffuse         : array[0..3] of GLfloat = ( 0.1, 0.5, 0.8, 1.0 );
    mat_specular        : array[0..3] of GLfloat = ( 1.0, 1.0, 1.0, 1.0 );
    no_shininess        : array[0..0] of GLfloat = ( 0.0 );
    low_shininess       : array[0..0] of GLfloat = ( 255.0 );
    high_shininess      : array[0..0] of GLfloat = ( 100.0 );
    mat_emission        : array[0..3] of GLfloat = ( 1, 1, 1, 0.0 );
var i,j:integer;
begin
glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);      //   

glPushMatrix;
glTranslatef(0,0,0.5*mas);
glColor4f (241/255, 121/255, 45/255, 0);
glScalef (1.2*mas, 1.2*mas, 1.2*mas);
  glMaterialfv (GL_FRONT, GL_AMBIENT_AND_DIFFUSE, @ColorMarker);

  glRotatef(ry, 0.0, 1.0, 0.0);               //l,NNt,del,dtrub,del_st,st_tr,xt,yt:double;
  glRotatef(tx, 1.0, 0, 0.0);

for j:=0 to ntx-1 do begin
for i:=0 to nty-1 do begin
glPushMatrix;
  glTranslatef(j*st_tr/l/2*mas, i*st_tr/l/2*mas, 0);
  gluDisk (quadObj, (dtrub-del_st)/2/l*mas, dtrub/2/l*mas,  20, 20);
  glTranslatef(0.0, 0.0, -0.5*mas);
  gluDisk (quadObj, (dtrub-del_st)/2/l*mas, dtrub/2/l*mas,  20, 20);
  gluCylinder (quadObj, dtrub/2/l*mas, dtrub/2/l*mas, 0.5*mas, 20, 10);

  glPopMatrix;
  end;
    end;

{glTranslatef ((-(st_tr-dtrub)/2/2/l+xt/2/l/2)*mas,(-(st_tr-dtrub)/2/2/l+yt/2/l/2)*mas ,(-del/2/2/l)*mas );
for i:=0 to npl do begin
glPushMatrix;
glTranslatef (0,0 ,(-i*del/2/l-i*0.2/2/l)*mas );
glScalef (xt/2/l*mas, yt/2/l*mas, 0.2/2/l*mas);
glutSolidCube(1);

glPopMatrix;
end;}

glPopMatrix;


SwapBuffers(DC);

end;

procedure TForm3.FormCreate(Sender: TObject);
const
    position        : array[0..3] of GLfloat = ( 1, -1.0, 1.0, 0.0 );

begin
 DC := GetDC (Handle);
 SetDCPixelFormat(DC);
 hrc := wglCreateContext(DC);
 wglMakeCurrent(DC, hrc);
// glClearColor (0.9, 0.9, 1, 1);
 glClearColor (0, 0, 0, 1);
 glLineWidth (15);
 glEnable(GL_NORMALIZE);
 glEnable(GL_DEPTH_TEST);
 glEnable(GL_AUTO_NORMAL);
 glLightfv(GL_LIGHT0, GL_AMBIENT, @LightAmbient);
 glLightfv(GL_LIGHT0, GL_DIFFUSE, @LightDiffuse);
 glLightfv(GL_LIGHT0, GL_SPECULAR, @LightSpecular);
 glLightfv(GL_LIGHT0, GL_POSITION, @LightPosition);
 glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @LightModelAmbient);
 glEnable (GL_LIGHTING);
 glEnable (GL_LIGHT0);



 glEnable (GL_COLOR_MATERIAL);
 glColor4f (0.4, 1, 0.6, 0.5);
  quadObj := gluNewQuadric;
mas:=1;
end;

procedure TForm3.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0, 0);
 wglDeleteContext(hrc);
 ReleaseDC (Handle, DC);
 DeleteDC (DC);

end;

procedure TForm3.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Key = VK_LEFT then begin
    ry := ry + 5.0;
    InvalidateRect(Handle, nil, False);
 end;
 If Key = VK_RIGHT then begin
    ry := ry - 5.0;
    InvalidateRect(Handle, nil, False);
 end;
 If Key = VK_UP then begin
    tx := tx - 5;
    InvalidateRect(Handle, nil, False);
 end;
 If Key = VK_DOWN then begin
    tx := tx + 5;
    InvalidateRect(Handle, nil, False);
 end;
if tx>360 then tx:=tx-360;
if tx<0 then tx:=tx+360;
if ry>360 then ry:=ry-360;
if ry<0 then ry:=ry+360;
Formpaint(sender);

end;

procedure TForm3.FormShow(Sender: TObject);
begin
del:=strtofloat(form1.edit29.Text);
dtrub:=strtofloat(form1.edit35.Text);
del_st:=strtofloat(form1.edit36.Text);
st_tr:=strtofloat(form1.edit39.Text);//      
xt:=strtofloat(form1.edit5.Text);     // 
yt:=strtofloat(form1.edit6.Text);     // 
l:=strtofloat(form1.edit4.Text)-130; //  =   - 2*
npl:=round(int(l/(del+0.2)+1));   //- 

NNt:=xt/st_tr;
NNt:=int(NNT);
Ntx:=round(NNT);         //-   
NNt:=yt/st_tr;
NNt:=int(NNT);
Nty:=round(NNT);//-   
if form1.combobox2.ItemIndex=0 then
if nty/2<>round(nty/2) then
nty:=nty-1;
if form1.combobox2.ItemIndex=1 then
if nty/2=round(nty/2) then
nty:=nty-1;
Nt:=Ntx*Nty; //  
end;

procedure TForm3.FormKeyPress(Sender: TObject; var Key: Char);
begin
if key=#43 then mas:=mas*1.05;
if key=#45 then mas:=mas/1.05;
end;

end.
